(
	function()
	{
		"use strict"

		var oPhotoCapture

		oPhotoCapture =
		{
			/*
			   ###    ######## ######## ########  #### ########  ##     ## ######## ########  ######
			  ## ##      ##       ##    ##     ##  ##  ##     ## ##     ##    ##    ##       ##    ##
			 ##   ##     ##       ##    ##     ##  ##  ##     ## ##     ##    ##    ##       ##
			##     ##    ##       ##    ########   ##  ########  ##     ##    ##    ######    ######
			#########    ##       ##    ##   ##    ##  ##     ## ##     ##    ##    ##             ##
			##     ##    ##       ##    ##    ##   ##  ##     ## ##     ##    ##    ##       ##    ##
			##     ##    ##       ##    ##     ## #### ########   #######     ##    ########  ######
			*/
			// <editor-fold desc="attributes">
			bPermission:	false,
			sUrl:	"/tmp/VideoSnapshotUpload/upload.php",

			oCanvasContext:	null,

			oElements:
			{
				canvas:	null,
				video:	null,
			},
			oDimesions:
			{
				height:	"320",
				width:	"240",
			},
			// </editor-fold>
			/*
			   ###     ######   ######  ########  ######   ######   #######  ########   ######
			  ## ##   ##    ## ##    ## ##       ##    ## ##    ## ##     ## ##     ## ##    ##
			 ##   ##  ##       ##       ##       ##       ##       ##     ## ##     ## ##
			##     ## ##       ##       ######    ######   ######  ##     ## ########   ######
			######### ##       ##       ##             ##       ## ##     ## ##   ##         ##
			##     ## ##    ## ##    ## ##       ##    ## ##    ## ##     ## ##    ##  ##    ##
			##     ##  ######   ######  ########  ######   ######   #######  ##     ##  ######
			*/
			// <editor-fold desc="accessors">
			get canvasContext()
			{
				return this.oCanvasContext
			},
			set canvasContext(oCanvasContext)
			{
				this.oCanvasContext = oCanvasContext
			},
			get dimensions()
			{
				return this.oDimesions
			},
			get elements()
			{
				return this.oElements
			},
			get permission()
			{
				return this.bPermission
			},
			set permission(bPermission)
			{
				this.bPermission = bPermission
			},
			get url()
			{
				return this.sUrl
			},
			/*
			######## ##     ## ######## ##    ## ########  ######
			##       ##     ## ##       ###   ##    ##    ##    ##
			##       ##     ## ##       ####  ##    ##    ##
			######   ##     ## ######   ## ## ##    ##     ######
			##        ##   ##  ##       ##  ####    ##          ##
			##         ## ##   ##       ##   ###    ##    ##    ##
			########    ###    ######## ##    ##    ##     ######
			*/
			// <editor-fold desc="events">
			onPermissionReceived()
			{
				this.permission = true
			},
			onStreamReceived(sStream)
			{
				this.elements.video.srcObject = sStream
				this.elements.video.play()
			},
			// </editor-fold>
			// </editor-fold>
			/*
			 ######  ######## ########  ##     ##  ######  ########  #######  ########   ######
			##    ##    ##    ##     ## ##     ## ##    ##    ##    ##     ## ##     ## ##    ##
			##          ##    ##     ## ##     ## ##          ##    ##     ## ##     ## ##
			 ######     ##    ########  ##     ## ##          ##    ##     ## ########   ######
			      ##    ##    ##   ##   ##     ## ##          ##    ##     ## ##   ##         ##
			##    ##    ##    ##    ##  ##     ## ##    ##    ##    ##     ## ##    ##  ##    ##
			 ######     ##    ##     ##  #######   ######     ##     #######  ##     ##  ######
			*/
			// <editor-fold desc="structors">
			initialize()
			{
				this.elements.canvas	= document.createElement("canvas")
				this.elements.canvas.width	= this.dimensions.width
				this.elements.canvas.height	= this.dimensions.height
				this.canvasContext	= this.elements.canvas.getContext("2d")
				this.elements.video	= document.createElement("video")
				this.elements.video.width	= this.dimensions.width
				this.elements.video.height	= this.dimensions.height

				navigator.mediaDevices.getUserMedia({video: true})
				.then
				(
					(sStream) =>
					{
						this.onPermissionReceived()
						this.onStreamReceived(sStream)
					}
				)

				return this
			},
			finalize()
			{
				this.elements.canvas.remove()
				this.elements.canvas	= null
				this.elements.video.remove()
				this.elements.video	= null

				return this
			},
			// </editor-fold>
			/*
			##     ## ######## ######## ##     ##  #######  ########   ######
			###   ### ##          ##    ##     ## ##     ## ##     ## ##    ##
			#### #### ##          ##    ##     ## ##     ## ##     ## ##
			## ### ## ######      ##    ######### ##     ## ##     ##  ######
			##     ## ##          ##    ##     ## ##     ## ##     ##       ##
			##     ## ##          ##    ##     ## ##     ## ##     ## ##    ##
			##     ## ########    ##    ##     ##  #######  ########   ######
			*/
			// <editor-fold desc="methods">
			/*
			########  ########  #### ##     ##    ###    ######## ########
			##     ## ##     ##  ##  ##     ##  ##   ##     ##    ##
			########  ########   ##  ##     ## ##     ##    ##    ######
			##        ##   ##    ##   ##   ##  #########    ##    ##
			##        ##     ## ####    ###    ##     ##    ##    ########
			*/
			// <editor-fold desc="private">
			_isBlank()
			{
				var oBlankCanvas

				oBlankCanvas	= document.createElement("canvas")
				oBlankCanvas.width	= this.elements.canvas.width
				oBlankCanvas.height	= this.elements.canvas.height

				return this.elements.canvas.toDataURL() == oBlankCanvas.toDataURL()
			},
			// </editor-fold>
			/*
			########  ##     ## ########  ##       ####  ######
			##     ## ##     ## ##     ## ##        ##  ##
			########  ##     ## ########  ##        ##  ##
			##        ##     ## ##     ## ##        ##  ##
			##         #######  ########  ######## ####  ######
			*/
			// <editor-fold desc="public">
			capture()
			{
				if(!this.permission)
				{
					throw new Error("Missing video capture permission!")
				}

				this.canvasContext.drawImage(this.elements.video, 0, 0, this.dimensions.width, this.dimensions.height)

				return this
			},
			show(eElement)
			{
				eElement.appendChild(this.elements.canvas)

				return this
			},
			upload()
			{
				if(!this.permission)
				{
					throw new Error("Missing video capture permission!")
				}
				if(this._isBlank())
				{
					throw new Error("No photo has been taken!")
				}

				this.elements.canvas.toBlob
				(
					(oBlob) =>
					{
						var	oFormData = new FormData(),
							oXhr = new XMLHttpRequest()

						oFormData.append("image", oBlob)
						oXhr.open("POST", this.url)
						oXhr.send(oFormData)
					}
				)

				return this
			},
			// </editor-fold>
			// </editor-fold>
		}

		document.addEventListener
		(
			"DOMContentLoaded",
			function()
			{
				oPhotoCapture.initialize()
			}
		)

		/*
		######## ##     ## ########   #######   ######  ##     ## ########  ########
		##        ##   ##  ##     ## ##     ## ##    ## ##     ## ##     ## ##
		##         ## ##   ##     ## ##     ## ##       ##     ## ##     ## ##
		######      ###    ########  ##     ##  ######  ##     ## ########  ######
		##         ## ##   ##        ##     ##       ## ##     ## ##   ##   ##
		##        ##   ##  ##        ##     ## ##    ## ##     ## ##    ##  ##
		######## ##     ## ##         #######   ######   #######  ##     ## ########
		*/
		// <editor-fold desc="exposure">
		if(window.metasec === undefined)
		{
			window.metasec = {}
		}
		window.metasec.photoCapture = oPhotoCapture
		// </editor-fold>
	}
)()
